CovidConsult/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
import homepage.urls as homepage
import forum.urls as forum
import authentication.urls as authentication
import consultation.urls as consultation
import article.urls as article
import obatpedia.urls as obatpedia
import profilepage.urls as profilepage

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(homepage)),
    path('forum/', include(forum)),
    path('accounts/', include(authentication)),
    path('article/',include(article)),
    path('consultation/', include(consultation)),
    path('obatpedia/', include(obatpedia)),
    path('apis/', include('apis.urls')), 
    path('profile/', include(profilepage))
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apis/urls.py
from django.urls import path

from .views import ListForum, DetailForum

urlpatterns = [
    path('forum/', ListForum.as_view()),
    path('forum/<int:pk>/', DetailForum.as_view()) 
]

authentication/urls.py
from django.urls import path
from .views import signup, login_user, logout_user, handle_signup, login_flutter, signup_flutter, logout_Flutter

app_name = 'authentication'

urlpatterns = [
    path('signup/', signup, name="SignUp"),
    path('signupAjax/', handle_signup, name="SignUpAjax"),
    path('login/', login_user, name="Login"),
    path('loginFlutter', login_flutter, name="LoginFlutter"),
    path('signupFlutter', signup_flutter, name="LoginFlutter"),
    path('logoutFlutter', logout_Flutter, name="LoginFlutter"),
    path('logout/', logout_user, name="Logout"),
]

authentication/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

# Create your models here.


class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    name = models.CharField(max_length=100)
    dob = models.DateField(blank=True, null=True)
    email = models.EmailField(max_length=100, blank=True, null=True)
    gender = models.CharField(max_length=30, blank=True, null=True)
    phone_num = models.CharField(max_length=15, blank=True, null=True)
    role = models.CharField(max_length=30, blank=True, null=True)
    profil_color = models.CharField(max_length=10, blank=True, null=True)

    def __str__(self):
        return self.name


@receiver(post_save, sender=User)
def create_user_profile(sender, instance, created, **kwargs):
    if created:
        Profile.objects.create(user=instance)


@receiver(post_save, sender=User)
def save_user_profile(sender, instance, **kwargs):
    instance.profile.save()

authentication/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm


ROLE_CHOICES = [
    ('doctor', 'Doctor'),
    ('patient', 'Visitor/Patient'),
]

GENDER_CHOICES = [
    ('male', 'Male'),
    ('female', 'Female')
]


class CreateUserForm(UserCreationForm):
    name = forms.CharField(max_length=100)
    dob = forms.DateField()
    email = forms.EmailField(max_length=100)
    phone_num = forms.CharField(max_length=15)

    # Radio button
    role_choice = forms.CharField(
        label="I'm a", widget=forms.RadioSelect(choices=ROLE_CHOICES))
    gender_choice = forms.CharField(
        label="I'm a", widget=forms.RadioSelect(choices=GENDER_CHOICES))

authentication/views.py
from django.contrib.auth.models import User
from django.http.response import JsonResponse
from django.contrib.auth.backends import UserModel  # langsung create model
from django.shortcuts import redirect, render
from .forms import CreateUserForm
from django.contrib.auth import authenticate, login, logout
from django.views.decorators.csrf import csrf_exempt
import random
import json


def signup(request):
    context = {}

    form = CreateUserForm(request.POST)

    context['form'] = form
    return render(request, "registerUser.html", context)


def handle_signup(request):
    form = CreateUserForm(request.POST)
    if form.is_valid():
        # Save user
        form.save()

        if request.method == 'POST':

            # Get data from forms.
            username = form.cleaned_data.get('username')
            name = form.cleaned_data.get('name')
            birth_date = form.cleaned_data.get('dob')
            email = form.cleaned_data.get("email")
            gender = form.cleaned_data.get('gender_choice')
            phone_number = form.cleaned_data.get("phone_num")
            role = form.cleaned_data.get("role_choice")

            print(username, name, birth_date,
                  email, gender, phone_number, role)

            # Edit the profile databases.
            update_profile(request, username, name, birth_date,
                           email, phone_number, gender, role)

            return JsonResponse({
                "id": "1",
                "message": "Account created"
            }, safe=False)  # biar ga ngecek jsonnnya valid / ngga

    return JsonResponse({
        "id": "2",
        "message": form.errors
    }, safe=False)


def login_user(request):

    if request.method == 'POST':
        username = request.POST.get('username')
        password = request.POST.get('password')

        user = authenticate(request, username=username, password=password)

        if user is not None:
            login(request, user)
            # redirect ke home
            return redirect('/')

    return render(request, 'login.html')


@csrf_exempt
def login_flutter(request):
    username = request.POST['username']
    password = request.POST['password']
    user = authenticate(username=username, password=password)
    if user is not None:
        if user.is_active:
            login(request, user)
            # Redirect to a success page.
            return JsonResponse({
                "status": True,
                "username": request.user.username,
                "name": user.profile.name,
                "dob": user.profile.dob,
                "email": user.profile.email,
                "phone_num": user.profile.phone_num,
                "role": user.profile.role,
                "gender": user.profile.gender,
                "message": "Successfully Logged In!"
            }, status=200)
        else:
            return JsonResponse({
                "status": False,
                "message": "Failed to Login!"
            }, status=401)

    else:
        return JsonResponse({
            "status": False,
            "message": "Failed to Login, your username/password may be wrong."
        }, status=401)


@csrf_exempt
def signup_flutter(request):
    if request.method == 'POST':
        data = json.loads(request.body)

        username = data["username"]
        email = data["email"]
        password1 = data["password"]
        name = data["name"]
        dob = data["dob"]
        gender = data["gender"]
        phone_num = data["phone_num"]
        role = data["role"]

        if User.objects.filter(username=username):
            print("masuk")
            return JsonResponse({"status": "User Exists"}, status=401)

        newUser = UserModel.objects.create_user(
            username=username,
            password=password1,
        )

        newUser.save()

        update_profile(request, username, name, dob,
                       email, phone_num, gender, role)

        return JsonResponse({"status": "success"}, status=200)
    else:
        return JsonResponse({"status": "error"}, status=401)


@csrf_exempt
def logout_Flutter(request):
    try:
        logout(request)
        return JsonResponse({
            "status": True,
            "message": "Successfully Logged out!"
        }, status=200)
    except:
        return JsonResponse({
            "status": False,
            "message": "Failed to Logout"
        }, status=401)


def logout_user(request):
    logout(request)
    return redirect('/')


def update_profile(request, user_username, name, birth_date, email, phone_number, gender, user_role):
    user = User.objects.get(username=user_username)
    user.profile.name = name
    user.profile.dob = birth_date
    user.profile.email = email
    user.profile.gender = gender
    user.profile.phone_num = phone_number
    user.profile.role = user_role
    user.profile.profil_color = generate_color()

    user.save()


def generate_color():
    COLOR = [
        "#6B46C1",  # ungu
        "#C14646",  # merah
        "#75C146",  # hijau
        "#4665C1",  # biru
        "#c1467b",  # pink
    ]
    return random.choice(COLOR)

authentication/templates/login.html
{% extends "base.html" %}
{% load static %}
{% block meta %}

<link
  rel="stylesheet"
  href="{% static 'authentication/CSS/login.css' %}"
/>

<script src="{% static 'authentication/JS/login.js' %}"></script>

{% endblock meta %}

<title>Login</title>

{% block content %}

<body>
  <div class="container">
    <div class="login-form">
      <div class="left-content">
        <img 
          src="{% static 'authentication/IMG/undraw_doctors_hwty.svg' %}"
          class="doctor-img" 
          alt="login image"/>
        <p class="quote">
          "Health is the thing that makes you feel 
          <br>
          now is the best time of year"
          <br>
          - Franklin P. Adams
        </p>
      </div>
      <div class="right-content">
        <h2 class="title">
          Hello 🙋‍♀️<br />
          Welcome Back
        </h2>
        <form method="POST" action="">
          {% csrf_token %}
          <div class="input-wrapper uname">
            <div class="i">
              <i class="fas fa-user"></i>
            </div>
            <div class="form-field">
              <input 
                type="text" 
                name="username" />
              <label>Username</label>
            </div>
          </div>
          <div class="input-wrapper pass">
            <div class="i">
              <i class="fas fa-lock"></i>
            </div>
            <div class="form-field">
              <input 
                type="password" 
                name="password" 
                required />
                <label>Password</label>
            </div>
          </div>
          <div class="d-grid">
            <input 
              class="btn btn-primary" 
              type="submit"
              value="Login" 
              style="background-color: #9f7aea">
            <p style="font-size: .9rem; margin-top: .5rem;">
              Don't have an account?
              <a href="{% url 'authentication:SignUp' %}">Register here</a>
            </p>
          </div>
        </form>        
      </div>
    </div>
  </div>
</body>


{% endblock content %}

authentication/templates/registerUser.html
{% extends "base.html" %}
{% load static %} 
{% block meta %}
<title>Sign Up</title>
<link
  rel="stylesheet"
  href="{% static 'authentication/CSS/registerUser.css' %}"
/>
<script src="{% static 'authentication/JS/signup.js' %}"></script>

{% endblock meta %} 
{% block content %}
<body>
  <div class="container d-flex justify-content-center">
    <div class="sign-up show">
      <form 
        method="POST" 
        action="{%url 'authentication:SignUpAjax'%}"
        class="form-signup">
        
        {% csrf_token %}
        <h2>✨ Hello ✨ <br>
          Sign up to get started</h2>
        <div class="flexing">
          <div class="form-left">
            <div class="input-wrapper-register mb-5">
              <input
                type="text"
                name="username">
              </input>
              <label>Username</label>
              <p class="uname-error" style="color: red; margin-top: 35px; margin-left: 12px;"></p>
            </div>
            <div class="input-wrapper-register mb-5">
              <input
              type="email"
              name="email">
              </input>
              <label>Email</label>
            </div>
            <div class="input-wrapper-register mb-5">
              <input
                type="text"
                name="phone_num">
              </input>
              <label>Phone Number</label>
            </div>
            <div class="input-wrapper-register mb-5">
              <input
              type="password"
              name="password1">
              </input>
              <label>Password</label>
            </div>
            <div class="input-wrapper-register mb-4">
              <input
              type="password"
              name="password2">
              </input>
              <label>Confirm Password</label>
              <p class="pass-error" style="color: red; margin-top: 35px; margin-left: 12px;"></p>
            </div>
          </div>
          <div class="form-right">
            <div class="input-wrapper-register mb-5">
              <input
              type="text"
              name="name">
              </input>
              <label>Name</label>
            </div>
            <div class="input-wrapper-register mb-5">
              <input
              type="text"
              name="dob"
              onfocus="(this.type='date')" 
              onblur="if(!this.value)this.type='text'">
              </input>
              <label>Date of Birth</label>
            </div>
            <div class="mt-4 mb-4 form-radio">
              <p style="margin-bottom:.2rem; font-size: 1.1rem;">Gender</p>
              <div class="choices">
                {{form.gender_choice}}
              </div>
            </div>
            <div class="form-group mb-5 form-radio">
              <p style="margin-bottom:.2rem; font-size: 1.1rem;">I'm a</p>
              <div class="choices">
                {{ form.role_choice }}
              </div>
            </div>
          </div>
        </div>
        <p class="mb-5" id="error" style="color:red"></p>
        <div class="d-grid">
          <input 
            class="btn btn-primary" 
            type="submit"
            value="Sign Up" 
            style="background-color: #9f7aea">
          <p style="font-size: 1rem; margin-top: .5rem;">
            Already have an account?
            <a href="{% url 'authentication:Login' %}">Login here</a>
          </p>
        </div>
      </form>
    </div>
  </div>
  <div class=" login hide container">  
    <div>
      <div class="container">
        <div class="login-form">
          <div class="left-content">
            <img 
              src="{% static 'authentication/IMG/undraw_doctors_hwty.svg' %}"
              class="doctor-img" 
              alt="login image"/>
            <p class="quote">
              "Health is the thing that make you feel 
              <br>
              now is the best time of year"
              <br>
              - Franklin P. Adams
            </p>
          </div>
          <div class="right-content">
            <h2 class="title">
              Hello 🙋‍♀️<br />
              Welcome Back
            </h2>
            <form method="POST" action="{% url 'authentication:Login' %}">
              {% csrf_token %}
              <div class="input-wrapper uname">
                <div class="i">
                  <i class="fas fa-user"></i>
                </div>
                <div class="form-field">
                  <input 
                    type="text" 
                    name="username" />
                  <label>Username</label>
                </div>
              </div>
              <div class="input-wrapper pass">
                <div class="i">
                  <i class="fas fa-lock"></i>
                </div>
                <div class="form-field">
                  <input 
                    type="password" 
                    name="password" 
                    required />
                    <label>Password</label>
                </div>
              </div>
              <div class="d-grid">
                <input 
                  class="btn btn-primary" 
                  type="submit"
                  value="Login" 
                  style="background-color: #9f7aea">
                <p style="font-size: .9rem; margin-top: .5rem;">
                  Don't have an account?
                  <a href="{% url 'authentication:SignUp' %}">Register here</a>
                </p>
              </div>
            </form>        
          </div>
        </div>
      </div>
    </div>
  </div>

</body>

{% endblock content %}